/*  briefomat
 *  Copyright (C) 1999 Stefan Heimers (stefan.heimers@kosta.ch)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 
 *  59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>

#include "briefomat.h"
#include "configs.h"


GtkWidget *adresse_feld;
GtkWidget *name_feld;
GtkWidget *email_feld;
GtkWidget *thema_feld;
GtkWidget *datum_feld;
GtkWidget *anrede_feld;
GtkWidget *gruss_feld;
GtkWidget *text8;
GtkWidget *pixmap2;
GtkWidget *header_entry_name;
GtkWidget *header_entry_street;
GtkWidget *header_entry_town;
GtkWidget *header_hbox;

char briefkopf;  //on=1 off=0
char *maildomain;
char *mail_user_name;
char *organisation;
char *header_street;
char *header_town;
char *header_phone;
char *header_fax;

GtkWidget*
get_widget     (GtkWidget       *widget,
               gchar           *widget_name)
{
  GtkWidget *found_widget;

  if (widget->parent)
    widget = gtk_widget_get_toplevel (widget);
  found_widget = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (widget),
                                                   widget_name);
  if (!found_widget)
    g_warning ("Widget not found: %s", widget_name);
  return found_widget;
}

/* This is an internally used function to set notebook tab widgets. */
void
set_notebook_tab                       (GtkWidget       *notebook,
                                        gint             page_num,
                                        GtkWidget       *widget)
{
  GtkNotebookPage *page;
  GtkWidget *notebook_page;

  page = (GtkNotebookPage*) g_list_nth (GTK_NOTEBOOK (notebook)->children, page_num)->data;
  notebook_page = page->child;
  gtk_widget_ref (notebook_page);
  gtk_notebook_remove_page (GTK_NOTEBOOK (notebook), page_num);
  gtk_notebook_insert_page (GTK_NOTEBOOK (notebook), notebook_page,
                            widget, page_num);
  gtk_widget_unref (notebook_page);
}

GtkWidget*
create_window1 ()
{
  char buffer[1000];
  char configfile[1000]; //vorsicht unsicher bei langen Filenamen
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *menubar1;
  GtkWidget *Datei;
  GtkWidget *menu18;
  GtkWidget *speichern;
  GtkWidget *_ffnen;
  GtkWidget *speichern_als;
  GtkWidget *separator1;
  GtkWidget *drucken;
  GtkWidget *faxen;
  GtkWidget *separator2;
  GtkWidget *Beenden;
  GtkWidget *Bearbeiten;
  GtkWidget *menu19;
  GtkWidget *kopieren;
  GtkWidget *einf_gen;
  GtkWidget *Optionen;
  GtkWidget *menu20;
  GtkWidget *briefkopf_ein_aus;
  GtkWidget *Hilfe;
  GtkWidget *menu21;
  GtkWidget *_ber;
  GtkWidget *header_hbox2;
  GtkWidget *header_vbox;
  GdkBitmap *glade_mask;
  GtkWidget *hbox2;
  GtkWidget *adress_label;
  GtkWidget *hbox3;

  GtkWidget *datum_label;
  GtkWidget *hbox4;
  GtkWidget *thema_label;
  GtkWidget *hbox5;
  GtkWidget *anrede_label;
  GtkWidget *alignment2;
  GtkWidget *hbox9;

  GtkWidget *vscrollbar2;
  GtkWidget *hbox6;

  GtkWidget *gruss_label;
  GtkWidget *unterschrift_label;
  GtkWidget *hbox7;

  GtkWidget *name_label;
  GtkWidget *hbox10;

  GtkWidget *email_label;
  //  GtkAccelGroup *accel_group;


 
  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (window1), "window1", window1);
  gtk_widget_set_usize (window1, 540, 690);
  gtk_window_set_title (GTK_WINDOW (window1), "brief-o-mat");
  gtk_window_set_policy (GTK_WINDOW (window1), TRUE, TRUE, FALSE);
   gtk_signal_connect (GTK_OBJECT (window1), "destroy",
                               GTK_SIGNAL_FUNC (on_Beenden_activate), NULL);


  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (window1), "vbox1", vbox1);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window1), vbox1);

  menubar1 = gtk_menu_bar_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "menubar1", menubar1);
  gtk_widget_show (menubar1);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar1, FALSE, TRUE, 0);

  Datei = gtk_menu_item_new_with_label ("Datei");
  gtk_object_set_data (GTK_OBJECT (window1), "Datei", Datei);
  gtk_widget_show (Datei);
  gtk_container_add (GTK_CONTAINER (menubar1), Datei);
  gtk_signal_connect (GTK_OBJECT (Datei), "activate",
                      GTK_SIGNAL_FUNC (on_Datei_activate),
                      NULL);

  menu18 = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "menu18", menu18);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Datei), menu18);

  speichern = gtk_menu_item_new_with_label ("speichern");
  gtk_object_set_data (GTK_OBJECT (window1), "speichern", speichern);
  gtk_widget_show (speichern);
  gtk_container_add (GTK_CONTAINER (menu18), speichern);
  gtk_signal_connect (GTK_OBJECT (speichern), "activate",
                      GTK_SIGNAL_FUNC (on_speichern_activate),
                      NULL);
  // accel_group = gtk_accel_group_new ();
  //gtk_window_add_accel_group (GTK_WINDOW (window1), accel_group);
  // gtk_widget_add_accelerator (speichern, "activate", accel_group,
  //                            GDK_S, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

  _ffnen = gtk_menu_item_new_with_label ("\366ffnen...");
  gtk_object_set_data (GTK_OBJECT (window1), "_ffnen", _ffnen);
  gtk_widget_show (_ffnen);
  gtk_container_add (GTK_CONTAINER (menu18), _ffnen);
  gtk_signal_connect (GTK_OBJECT (_ffnen), "activate",
                      GTK_SIGNAL_FUNC (on__ffnen_activate),
                      NULL);
  //  gtk_widget_add_accelerator (_ffnen, "activate", accel_group,
  //                          GDK_O, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

  speichern_als = gtk_menu_item_new_with_label ("speichern als...");
  gtk_object_set_data (GTK_OBJECT (window1), "speichern_als", speichern_als);
  gtk_widget_show (speichern_als);
  gtk_container_add (GTK_CONTAINER (menu18), speichern_als);
  gtk_signal_connect (GTK_OBJECT (speichern_als), "activate",
                      GTK_SIGNAL_FUNC (on_speichern_als_activate),
                      NULL);

  separator1 = gtk_menu_item_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "separator1", separator1);
  gtk_widget_show (separator1);
  gtk_container_add (GTK_CONTAINER (menu18), separator1);

  drucken = gtk_menu_item_new_with_label ("drucken...");
  gtk_object_set_data (GTK_OBJECT (window1), "drucken", drucken);
  gtk_widget_show (drucken);
  gtk_container_add (GTK_CONTAINER (menu18), drucken);
  gtk_signal_connect (GTK_OBJECT (drucken), "activate",
                      GTK_SIGNAL_FUNC (on_drucken_activate),
                      NULL);
  //gtk_widget_add_accelerator (drucken, "activate", accel_group,
  //                            GDK_P, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

  faxen = gtk_menu_item_new_with_label ("faxen...");
  gtk_object_set_data (GTK_OBJECT (window1), "faxen", faxen);
  gtk_widget_show (faxen);
  gtk_container_add (GTK_CONTAINER (menu18), faxen);
  gtk_signal_connect (GTK_OBJECT (faxen), "activate",
                      GTK_SIGNAL_FUNC (on_faxen_activate),
                      NULL);
  //gtk_widget_add_accelerator (faxen, "activate", accel_group,
  //                            GDK_F, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

  separator2 = gtk_menu_item_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "separator2", separator2);
  gtk_widget_show (separator2);
  gtk_container_add (GTK_CONTAINER (menu18), separator2);

  Beenden = gtk_menu_item_new_with_label ("Beenden");
  gtk_object_set_data (GTK_OBJECT (window1), "Beenden", Beenden);
  gtk_widget_show (Beenden);
  gtk_container_add (GTK_CONTAINER (menu18), Beenden);
  gtk_signal_connect (GTK_OBJECT (Beenden), "activate",
                      GTK_SIGNAL_FUNC (on_Beenden_activate),
                      NULL);
  // gtk_widget_add_accelerator (Beenden, "activate", accel_group,
  //                            GDK_Q, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

  Bearbeiten = gtk_menu_item_new_with_label ("Bearbeiten");
  gtk_object_set_data (GTK_OBJECT (window1), "Bearbeiten", Bearbeiten);
  gtk_widget_show (Bearbeiten);
  gtk_container_add (GTK_CONTAINER (menubar1), Bearbeiten);
  gtk_signal_connect (GTK_OBJECT (Bearbeiten), "activate",
                      GTK_SIGNAL_FUNC (on_Bearbeiten_activate),
                      NULL);

  menu19 = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "menu19", menu19);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Bearbeiten), menu19);

  kopieren = gtk_menu_item_new_with_label ("kopieren");
  gtk_object_set_data (GTK_OBJECT (window1), "kopieren", kopieren);
  gtk_widget_show (kopieren);
  gtk_container_add (GTK_CONTAINER (menu19), kopieren);
  gtk_signal_connect (GTK_OBJECT (kopieren), "activate",
                      GTK_SIGNAL_FUNC (on_kopieren_activate),
                      NULL);
  // gtk_widget_add_accelerator (kopieren, "activate", accel_group,
  //                            GDK_C, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

  einf_gen = gtk_menu_item_new_with_label ("einf\374gen");
  gtk_object_set_data (GTK_OBJECT (window1), "einf_gen", einf_gen);
  gtk_widget_show (einf_gen);
  gtk_container_add (GTK_CONTAINER (menu19), einf_gen);
  gtk_signal_connect (GTK_OBJECT (einf_gen), "activate",
                      GTK_SIGNAL_FUNC (on_einf_gen_activate),
                      NULL);
  //gtk_widget_add_accelerator (einf_gen, "activate", accel_group,
  //                            GDK_V, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

  Optionen = gtk_menu_item_new_with_label ("Optionen");
  gtk_object_set_data (GTK_OBJECT (window1), "Optionen", Optionen);
  gtk_widget_show (Optionen);
  gtk_container_add (GTK_CONTAINER (menubar1), Optionen);
  gtk_signal_connect (GTK_OBJECT (Optionen), "activate",
                      GTK_SIGNAL_FUNC (on_Optionen_activate),
                      NULL);

  menu20 = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "menu20", menu20);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Optionen), menu20);

  briefkopf_ein_aus = gtk_menu_item_new_with_label ("Briefkopf ein/aus");
  gtk_object_set_data (GTK_OBJECT (window1), "briefkopf_ein_aus", briefkopf_ein_aus);
  gtk_widget_show (briefkopf_ein_aus);
  gtk_container_add (GTK_CONTAINER (menu20), briefkopf_ein_aus);
  gtk_signal_connect (GTK_OBJECT (briefkopf_ein_aus), "activate",
                      GTK_SIGNAL_FUNC (on_briefkopf_ein_aus_activate),
                      NULL);
  // gtk_widget_add_accelerator (briefkopf_ein_aus, "activate", accel_group,
  //                          GDK_B, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

  Hilfe = gtk_menu_item_new_with_label ("Hilfe");
  gtk_object_set_data (GTK_OBJECT (window1), "Hilfe", Hilfe);
  gtk_widget_show (Hilfe);
  gtk_container_add (GTK_CONTAINER (menubar1), Hilfe);
  gtk_signal_connect (GTK_OBJECT (Hilfe), "activate",
                      GTK_SIGNAL_FUNC (on_Hilfe_activate),
                      NULL);
  gtk_menu_item_right_justify (GTK_MENU_ITEM (Hilfe));

  menu21 = gtk_menu_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "menu21", menu21);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (Hilfe), menu21);

  _ber = gtk_menu_item_new_with_label ("\334ber...");
  gtk_object_set_data (GTK_OBJECT (window1), "_ber", _ber);
  gtk_widget_show (_ber);
  gtk_container_add (GTK_CONTAINER (menu21), _ber);
  gtk_signal_connect (GTK_OBJECT (_ber), "activate",
                      GTK_SIGNAL_FUNC (on__ber_activate),
                      NULL);

  gtk_widget_realize (window1);
  header_hbox=gtk_hbox_new(FALSE,0);
  header_hbox2=gtk_hbox_new(FALSE,0);
  header_vbox=gtk_vbox_new(FALSE,0); 
  gtk_box_pack_start (GTK_BOX (vbox1), header_hbox, FALSE, TRUE, 0);


  gtk_widget_show(header_vbox);
  gtk_widget_show(header_hbox2);
  header_entry_name = gtk_entry_new ();
  gtk_container_add (GTK_CONTAINER (header_hbox),header_entry_name);  
  gtk_container_add (GTK_CONTAINER (header_hbox), header_vbox);
  gtk_container_add (GTK_CONTAINER (header_vbox), header_hbox2);
  header_entry_street = gtk_entry_new();
  gtk_container_add (GTK_CONTAINER (header_vbox),header_entry_street);
  header_entry_town = gtk_entry_new();
  gtk_container_add (GTK_CONTAINER (header_vbox),header_entry_town);
  gtk_widget_show(header_entry_name);
  gtk_widget_show(header_entry_street);
  gtk_widget_show(header_entry_town);
  briefkopf  = (char) conf_long_get("/etc/briefomatrc","BRIEFKOPF");
  configfile[0]='\0';
  strcpy(configfile,getenv("HOME"));
  strcat(configfile,"/.briefomatrc");
  briefkopf  = (char) conf_long_get(configfile,"BRIEFKOPF");
  if (briefkopf)
    gtk_widget_show(header_hbox);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (window1), "hbox2", hbox2);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, TRUE, 0);
  gtk_widget_set_usize (hbox2, -1, 70);

  adresse_feld = gtk_text_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (window1), "adresse_feld", adresse_feld);
  //gtk_entry_set_text (GTK_ENTRY (adresse_feld), "Hans Muster"  );
  gtk_widget_show (adresse_feld);
  gtk_box_pack_start (GTK_BOX (hbox2), adresse_feld, FALSE, TRUE, 0);
  gtk_widget_set_usize (adresse_feld, 180, 60);
  /* gtk_widget_realize (adresse_feld);
  gtk_text_freeze( (GtkText *)adresse_feld);
  gtk_text_insert( (GtkText *)adresse_feld,NULL,NULL, NULL,"Hans Muster",-1 );
  gtk_text_thaw( (GtkText *)adresse_feld);*/
  gtk_text_set_editable (GTK_TEXT (adresse_feld), TRUE);

  adress_label = gtk_label_new ("Adresse");
  gtk_object_set_data (GTK_OBJECT (window1), "adress_label", adress_label);
  gtk_widget_show (adress_label);
  gtk_box_pack_start (GTK_BOX (hbox2), adress_label, FALSE, TRUE, 0);
  gtk_widget_set_usize (adress_label, 80, -1);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (window1), "hbox3", hbox3);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, FALSE, TRUE, 0);

  datum_feld = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "datum_feld", datum_feld);
  gtk_widget_show (datum_feld);
  gtk_box_pack_start (GTK_BOX (hbox3), datum_feld, FALSE, TRUE, 0);
  gtk_widget_set_usize (datum_feld, 180, -1);
  gtk_entry_set_text (GTK_ENTRY (datum_feld), "\\today"  );

  datum_label = gtk_label_new ("Datum");
  gtk_object_set_data (GTK_OBJECT (window1), "datum_label", datum_label);
  gtk_widget_show (datum_label);
  gtk_box_pack_start (GTK_BOX (hbox3), datum_label, FALSE, TRUE, 0);
  gtk_widget_set_usize (datum_label, 80, -1);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (window1), "hbox4", hbox4);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox4, FALSE, TRUE, 0);

  thema_feld = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "thema_feld", thema_feld);
  gtk_widget_show (thema_feld);
  gtk_box_pack_start (GTK_BOX (hbox4), thema_feld, FALSE, TRUE, 0);
  gtk_widget_set_usize (thema_feld, 180, -1);

  thema_label = gtk_label_new ("Thema");
  gtk_object_set_data (GTK_OBJECT (window1), "thema_label", thema_label);
  gtk_widget_show (thema_label);
  gtk_box_pack_start (GTK_BOX (hbox4), thema_label, FALSE, TRUE, 0);
  gtk_widget_set_usize (thema_label, 80, -1);

  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (window1), "hbox5", hbox5);
  gtk_widget_show (hbox5);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox5, FALSE, TRUE, 0);

  anrede_feld = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "anrede_feld", anrede_feld);
  gtk_widget_show (anrede_feld);
  gtk_box_pack_start (GTK_BOX (hbox5), anrede_feld, TRUE, TRUE, 0);

  anrede_label = gtk_label_new ("Anrede");
  gtk_object_set_data (GTK_OBJECT (window1), "anrede_label", anrede_label);
  gtk_widget_show (anrede_label);
  gtk_box_pack_start (GTK_BOX (hbox5), anrede_label, TRUE, TRUE, 0);

  alignment2 = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_object_set_data (GTK_OBJECT (window1), "alignment2", alignment2);
  gtk_widget_show (alignment2);
  gtk_box_pack_start (GTK_BOX (vbox1), alignment2, TRUE, TRUE, 0);

  hbox9 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (window1), "hbox9", hbox9);
  gtk_widget_show (hbox9);
  gtk_container_add (GTK_CONTAINER (alignment2), hbox9);

  text8 = gtk_text_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (window1), "text8", text8);
  gtk_widget_show (text8);
  gtk_box_pack_start (GTK_BOX (hbox9), text8, TRUE, TRUE, 0);
  gtk_widget_set_usize (text8, 402, 300);
  gtk_text_set_editable (GTK_TEXT (text8), TRUE);

  vscrollbar2 = gtk_vscrollbar_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 0, 0, 0, 0)));
  gtk_object_set_data (GTK_OBJECT (window1), "vscrollbar2", vscrollbar2);
  gtk_widget_show (vscrollbar2);
  gtk_box_pack_start (GTK_BOX (hbox9), vscrollbar2, FALSE, TRUE, 0);

  hbox6 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (window1), "hbox6", hbox6);
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox6, FALSE, TRUE, 0);

  gruss_feld = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "gruss_feld", gruss_feld);
  gtk_widget_show (gruss_feld);
  gtk_box_pack_start (GTK_BOX (hbox6), gruss_feld, TRUE, TRUE, 0);
  gtk_entry_set_text (GTK_ENTRY (gruss_feld), "Mit freundlichen Gr\374ssen");

  gruss_label = gtk_label_new ("Gruss");
  gtk_object_set_data (GTK_OBJECT (window1), "gruss_label", gruss_label);
  gtk_widget_show (gruss_label);
  gtk_box_pack_start (GTK_BOX (hbox6), gruss_label, TRUE, TRUE, 0);

  unterschrift_label = gtk_label_new ("Unterschrift (handschriftlich auszuf\374llen)");
  gtk_object_set_data (GTK_OBJECT (window1), "unterschrift_label", unterschrift_label);
  gtk_widget_show (unterschrift_label);
  gtk_box_pack_start (GTK_BOX (vbox1), unterschrift_label, FALSE, TRUE, 0);
  gtk_widget_set_usize (unterschrift_label, 100, 23);

  hbox7 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (window1), "hbox7", hbox7);
  gtk_widget_show (hbox7);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox7, FALSE, TRUE, 0);

  name_feld = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "name_feld", name_feld);
  gtk_widget_show (name_feld);
  gtk_box_pack_start (GTK_BOX (hbox7), name_feld, TRUE, TRUE, 0);
  gtk_widget_set_usize (name_feld, 80, -1);

  name_label = gtk_label_new ("Name");
  gtk_object_set_data (GTK_OBJECT (window1), "name_label", name_label);
  gtk_widget_show (name_label);
  gtk_box_pack_start (GTK_BOX (hbox7), name_label, FALSE, TRUE, 0);
  gtk_widget_set_usize (name_label, 80, -1);

  hbox10 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (window1), "hbox10", hbox10);
  gtk_widget_show (hbox10);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox10, TRUE, TRUE, 0);

  email_feld = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "email_feld", email_feld);
  gtk_widget_show (email_feld);
  gtk_box_pack_start (GTK_BOX (hbox10), email_feld, TRUE, TRUE, 0);
  gtk_widget_set_usize (email_feld, 80, -1);


  email_label = gtk_label_new ("Email");
  gtk_object_set_data (GTK_OBJECT (window1), "email_label", email_label);
  gtk_widget_show (email_label);
  gtk_box_pack_start (GTK_BOX (hbox10), email_label, FALSE, TRUE, 0);
  gtk_widget_set_usize (email_label, 80, -1);
  init_config(); //this must be after creating the widgets because it
                 //directly sets some Widget-Attributes
  return window1;
}

















