/*  briefomat
 *  Copyright (C) 1999 Stefan Heimers 
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <gtk/gtk.h>
#include "briefomat.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <pthread.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>


pthread_t tmptex_thread;
char *globalfilename=0;

int
main (int argc, char *argv[])
{
  GtkWidget *window1;

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */

  window1 = create_window1 ();
  printf("debug: argc= %d\n",argc);
  if(argc>1) //filename specified on commandline
    {
      globalfilename=argv[1];
    }
  gtk_widget_show (window1);
   extract_entries(0,0);
  gtk_main ();
  return 0;
}


void
on_Datei_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void file_ok(GtkWidget *w,GtkFileSelection *dateidialog)
{
char befehl[1000];//einfach mal auf Vorrat
globalfilename=gtk_file_selection_get_filename (GTK_FILE_SELECTION (dateidialog));
sprintf(befehl,"cp %s/briefomat-tmp.tex %s",getenv("HOME"),globalfilename);
pthread_join(tmptex_thread,NULL);
system(befehl);
gtk_widget_destroy((GtkWidget *)dateidialog);
}


void close_it(GtkWidget     *w,GtkWidget *w2)
{
gtk_widget_destroy(w2);
}

void
on_speichern_als_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

  GtkWidget *dateidialog;
  char buffer[1000];

  sprintf(buffer,"%s/unnamed.btex",getenv("HOME"));
  dateidialog=gtk_file_selection_new("Brief speichern unter...");
  gtk_file_selection_set_filename(GTK_FILE_SELECTION (dateidialog),buffer);
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (dateidialog)->ok_button), "clicked",GTK_SIGNAL_FUNC (file_ok),dateidialog);
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (dateidialog)->cancel_button), "clicked",(GtkSignalFunc) close_it,GTK_OBJECT (dateidialog));
  gtk_widget_show(dateidialog);
  pthread_create(&tmptex_thread,NULL,mk_tmp_tex,NULL);
}


void
on__ffnen_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
readfile();
}


void
on_speichern_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
if (globalfilename==0)
  on_speichern_als_activate(menuitem,user_data);
else
  {
     char buffer[1000];

     sprintf(buffer,"cp -f %s/briefomat-tmp.tex %s",getenv("HOME"),globalfilename);
     mk_tmp_tex();
     system(buffer);
  }
}


void
on_drucken_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  pthread_t print_thread;
  pthread_create(&print_thread,NULL,do_print_thread,NULL);
}


void
on_faxen_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_Beenden_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  system("killall latex"); //terminate Background Tasks
  system("killall dvips");
  gtk_main_quit ();
  exit(0);
}


void
on_Bearbeiten_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_kopieren_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_einf_gen_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_Optionen_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_briefkopf_ein_aus_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
briefkopf = !briefkopf;
if (briefkopf)
  gtk_widget_show(header_hbox);
else
  gtk_widget_hide(header_hbox);
}


void
on_Hilfe_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on__ber_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
GtkWidget *ueberdialog,*label;
ueberdialog = gtk_dialog_new();
label=gtk_label_new("Brief-O-Mat\n(c) by Stefan Heimers 1999\n
  This program is 
  free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.");
gtk_box_pack_start (GTK_BOX (GTK_DIALOG (ueberdialog)->vbox), label, TRUE,
                          TRUE, 0);
gtk_widget_show(label);
gtk_widget_show(ueberdialog);

}
























