/*  briefomat
 *  Copyright (C) 1999 Stefan Heimers (stefan.heimers@kosta.ch)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 
 *  59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


/*
Funktionsbeschreibung:

Jeder Eintrag hat einen Namen aus min. 3Buchstaben oder Zahlen aber
ohne Leerschlag oder Tabulator. Nach dem Namen folgt ein Tabulator
(\t), der das Ende des Namens anzeigt. Nach dem Tabulator folgt ein
String, der entweder als String oder per scanf als Zahl ausgelesen
wird. Zahlen werden also auch als String gespeichert, um die
Lesbarkeit im Texteditor zu verbessern. Der Eintrag wird durch ein \n
beendet.

Der *.tex -> briefomat Parser ist in readfile.c, nicht hier
*/ 

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>





char is_item(char *filename, char *item)
{
int fd;
unsigned int i,j;
char *name;
size_t length;

name=(char *)malloc(50000);
if( (fd=open(filename,O_RDONLY))!=-1 )
 length=read(fd,name,50000);//read the whole file
else
  return 0;
i=0;
 label:
j=0;
while( (name[i]==item[j]) * (i<length) )
  {
    i++;
    j++;
  }
if( (j>2) * (name[i]=='\t') ) //item found
  {
    close(fd);
    free(name);
  return 1;
  }
else
  if(i<length)
    {
      i++;
      goto label;
    }
close(fd);
free(name);
return 0;
}

char *conf_string_get(char *filename, char *item)
{
  int fd;
  unsigned int i,j;
  char *name,*result;
  size_t length;
  
  name=(char *)malloc(5000);
  if ((fd=open(filename,O_RDONLY))==-1)
  { 
    printf("File %s not opened\n",filename); 
  }
  else
    {

      length=read(fd,name,5000);//read the whole file
      if(length<0) 
	{
	  printf("file read failure: %s\n",filename);
	  exit(1);
	}
      close(fd);
      i=0;
    label:
      j=0;
      while(  (i<length) * (j<strlen(item)) * (name[i]==item[j])  )
	{
	  i++;
	  j++;
	}
      if( (j>2) * ( (name[i]=='\t')+(name[i]==' ') ) ) //item found
	{
	  j=0;
	  i++;
	  while(name[i]!='\n')
	    {
	    i++;
	    j++;
	    }
	  result=(char *)malloc(j+1);
	  strncpy(result,&name[i-j],j);
	  result[j]='\0';
	  free(name);
	  return result;
	}
      else
	if(i<length)
	  {
	    i++;
	    goto label;
	  }
	else
	  return (char *)NULL; 
    }
  free(name);
  return "";
}

long conf_long_get(char *filename, char *item)
{
return atol(conf_string_get(filename,item));
}

double conf_double_get(char *filename, char *item)
{
return atof(conf_string_get(filename,item));

}


void conf_string_set()
{

}

void conf_long_set()
{

}

void conf_double_set()
{

}

/*
//nur fr Testzwecke
int main()
{
printf("is_item() returns: %d\n\n", (int) is_item("/tmp/testrc","testitem"));
printf("value is: %s\n", conf_string_get("/tmp/testrc","testitem"));
printf("double: %f\n",conf_double_get("/tmp/testrc","testdouble"));
}
*/
















