#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "briefomat.h"


char *readfile()
{
  GtkWidget *readfilediag;
  readfilediag =  gtk_file_selection_new( "Datei ffnen" );
  gtk_signal_connect (GTK_OBJECT (readfilediag), "destroy", \
            (GtkSignalFunc) gtk_widget_destroy, &readfilediag);
  gtk_signal_connect(GTK_OBJECT (GTK_FILE_SELECTION (readfilediag)->cancel_button),   \
	    "clicked", (GtkSignalFunc) close_it, readfilediag);
  gtk_signal_connect(GTK_OBJECT (GTK_FILE_SELECTION (readfilediag)->ok_button),   \
	    "clicked", (GtkSignalFunc) extract_entries,  GTK_OBJECT (readfilediag));
  
  gtk_widget_show( readfilediag);
}

char  *next_line(char *buffer)
{
while(buffer[0]!='\n')
  {
  buffer++;
  if(buffer[0]=='\0')
    return 0;
  }
buffer++;
return buffer;
}


char *is_command(char *command,char *buffer) 
     /*return buffer after command  if beginning of buffer 
       matches command, else 0 */
{
while(buffer[0]==command[0])
  {
    buffer++;
    command++;
    if (command[0]=='\0')
      return buffer;      //command found, return buffer at data position
    if (  (buffer[0]=='\0') * (buffer[0]=='\n'))
      return 0;           //end of buffer or line reached
  }
 return 0; //string mismatch
}


char *next_tex_command(char *buffer)
     /* advance buffer position to next '\' */
{
if(buffer[0]=='\\')
  buffer++;
while (buffer[0]!='\\')
  {
    if (buffer[0]=='\0')  //end of buffer reached
      return 0;
    else
      buffer++;
  }
return buffer;
}



restore_anyentry(char *buffer,GtkWidget *entry)
{
int i=0;
while(buffer[i]!='}')
  i++;
buffer[i]='\0';
gtk_entry_set_text((GtkEntry *) entry,(const gchar *)buffer );
buffer[i]='}';
}

restore_text(char *buffer)
{
int i=0;
while(!is_command("\\end{g",buffer+i))
  i++;
buffer[i]='\0';
 gtk_text_insert( (GtkText *)text8,NULL,NULL, NULL,buffer,-1 ); 
buffer[i]='}';
}

restore_adresse(char *buffer)
{
int i=0;
while(buffer[i]!='}')
  {
    if (buffer[i]=='\\')
      {
	buffer[i]=' ';
	i++;
	buffer[i]='\n';
      }
    i++;
  }
buffer[i]='\0';
 gtk_text_insert( (GtkText *)adresse_feld,NULL,NULL, NULL,buffer,-1 ); 
buffer[i]='}';
}



int texparse(char *buffer)
{
  char *local_buffer;
  while((buffer=next_tex_command(buffer))!=0)
    {
      if ((local_buffer=is_command("\\Name {",buffer)))
	restore_anyentry(local_buffer,header_entry_name);
      if ((local_buffer=is_command("\\begin{g-brief}",buffer)))
	restore_text(local_buffer);
      if ((local_buffer=is_command("\\Strasse {",buffer)))
	restore_anyentry(local_buffer,header_entry_street);
      if ((local_buffer=is_command("\\Ort {",buffer)))
	restore_anyentry(local_buffer,header_entry_town);
      /*    if ((local_buffer=is_command("\\Telefon {",buffer)))
	    restore_anyentry(local_buffer,); */
      if ((local_buffer=is_command("\\EMail {",buffer)))
	restore_anyentry(local_buffer,email_feld);
      if ((local_buffer=is_command("\\Unterschrift {",buffer)))
	restore_anyentry(local_buffer,name_feld);
      if ((local_buffer=is_command("\\Datum {",buffer)))
	restore_anyentry(local_buffer,datum_feld);
      if ((local_buffer=is_command("\\Gruss {",buffer)))
	restore_anyentry(local_buffer,gruss_feld);
      if ((local_buffer=is_command("\\Adresse {",buffer)))
	restore_adresse(local_buffer);
      if ((local_buffer=is_command("\\Anrede {",buffer)))
	restore_anyentry(local_buffer,anrede_feld);


    }
  return 0;  //not useful yet, later for error handling
}


void extract_entries(GtkWidget     *w,GtkWidget *filesel)
{
  char *filename;
  int fd;
  struct stat filestat;
  char *data;
  if (filesel!=0)
    filename=gtk_file_selection_get_filename((GtkFileSelection *) filesel );
  else
    filename=globalfilename;
  if( (fd=open(filename,O_RDWR)) == -1 )
    printf("Kann Datei nicht lesen\n");
  else
    {
      stat(filename,&filestat);
      data=(char *)malloc(filestat.st_size+1);
      read(fd,data,filestat.st_size);
      data[filestat.st_size]='\0'; //I don't know if this is necessary
      texparse(data);
    }
  printf("Debug: Filesize: %d\n",(int)filestat.st_size);
  if(filesel!=0)
    close_it(w,filesel);
}












